# CfnFileSystem

The `AWS::EFS::FileSystem` resource creates a new, empty file system in Amazon Elastic File System ( Amazon EFS ).

You must create a mount target ( [AWS::EFS::MountTarget](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-mounttarget.html) ) to mount your EFS file system on an Amazon EC2 or other AWS cloud compute resource.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnFileSystem
Implements: IInspectable, ITaggable, IEnvironmentAware, IFileSystemRef, IConstruct, IDependable

- CloudFormation: [`AWS::EFS::FileSystem`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-efs-filesystem.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_efs as efs } from 'aws-cdk-lib';

declare const fileSystemPolicy: any;
const cfnFileSystem = new efs.CfnFileSystem(this, 'MyCfnFileSystem', /* all optional props */ {
  availabilityZoneName: 'availabilityZoneName',
  backupPolicy: {
    status: 'status',
  },
  bypassPolicyLockoutSafetyCheck: false,
  encrypted: false,
  fileSystemPolicy: fileSystemPolicy,
  fileSystemProtection: {
    replicationOverwriteProtection: 'replicationOverwriteProtection',
  },
  fileSystemTags: [{
    key: 'key',
    value: 'value',
  }],
  kmsKeyId: 'kmsKeyId',
  lifecyclePolicies: [{
    transitionToArchive: 'transitionToArchive',
    transitionToIa: 'transitionToIa',
    transitionToPrimaryStorageClass: 'transitionToPrimaryStorageClass',
  }],
  performanceMode: 'performanceMode',
  provisionedThroughputInMibps: 123,
  replicationConfiguration: {
    destinations: [{
      availabilityZoneName: 'availabilityZoneName',
      fileSystemId: 'fileSystemId',
      kmsKeyId: 'kmsKeyId',
      region: 'region',
      roleArn: 'roleArn',
      status: 'status',
      statusMessage: 'statusMessage',
    }],
  },
  throughputMode: 'throughputMode',
});
```

## Initializer

```ts
new CfnFileSystem(scope: Construct, id: string, props?: CfnFileSystemProps)
```

## Construct Props

- `availabilityZoneName`: string — For One Zone file systems, specify the AWS Availability Zone in which to create the file system.

  Use the format `us-east-1a` to specify the Availability Zone. For more information about One Zone file systems, see [EFS file system types](https://docs.aws.amazon.com/efs/latest/ug/availability-durability.html#file-system-type) in the *Amazon EFS User Guide* .

  > One Zone file systems are not available in all Availability Zones in AWS Regions where Amazon EFS is available.

- `backupPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.BackupPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.BackupPolicyProperty.html) — Use the `BackupPolicy` to turn automatic backups on or off for the file system.

- `bypassPolicyLockoutSafetyCheck`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — (Optional) A boolean that specifies whether or not to bypass the `FileSystemPolicy` lockout safety check.

  The lockout safety check determines whether the policy in the request will lock out, or prevent, the IAM principal that is making the request from making future `PutFileSystemPolicy` requests on this file system. Set `BypassPolicyLockoutSafetyCheck` to `True` only when you intend to prevent the IAM principal that is making the request from making subsequent `PutFileSystemPolicy` requests on this file system. The default value is `False` .

- `encrypted`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A Boolean value that, if true, creates an encrypted file system.

  When creating an encrypted file system, you have the option of specifying a KmsKeyId for an existing AWS KMS key . If you don't specify a KMS key , then the default KMS key for Amazon EFS , `/aws/elasticfilesystem` , is used to protect the encrypted file system.

- `fileSystemPolicy`: any — The `FileSystemPolicy` for the EFS file system.

  A file system policy is an IAM resource policy used to control NFS access to an EFS file system. For more information, see [Using IAM to control NFS access to Amazon EFS](https://docs.aws.amazon.com/efs/latest/ug/iam-access-control-nfs-efs.html) in the *Amazon EFS User Guide* .

- `fileSystemProtection`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.FileSystemProtectionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.FileSystemProtectionProperty.html) — Describes the protection on the file system.

- `fileSystemTags`: [CfnFileSystem.ElasticFileSystemTagProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.ElasticFileSystemTagProperty.html)[] — Use to create one or more tags associated with the file system.

  Each tag is a user-defined key-value pair. Name your file system on creation by including a `"Key":"Name","Value":"{value}"` key-value pair. Each key must be unique. For more information, see [Tagging AWS resources](https://docs.aws.amazon.com/general/latest/gr/aws_tagging.html) in the *AWS General Reference Guide* .

- `kmsKeyId`: string | [IKeyRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_kms.IKeyRef.html) — The ID of the AWS KMS key to be used to protect the encrypted file system.

  This parameter is only required if you want to use a nondefault KMS key . If this parameter is not specified, the default KMS key for Amazon EFS is used. This ID can be in one of the following formats:

  - Key ID - A unique identifier of the key, for example `1234abcd-12ab-34cd-56ef-1234567890ab` .
  - ARN - An Amazon Resource Name (ARN) for the key, for example `arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab` .
  - Key alias - A previously created display name for a key, for example `alias/projectKey1` .
  - Key alias ARN - An ARN for a key alias, for example `arn:aws:kms:us-west-2:444455556666:alias/projectKey1` .

  If `KmsKeyId` is specified, the `Encrypted` parameter must be set to true.

- `lifecyclePolicies`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.LifecyclePolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.LifecyclePolicyProperty.html)[] — An array of `LifecyclePolicy` objects that define the file system's `LifecycleConfiguration` object.

  A `LifecycleConfiguration` object informs Lifecycle management of the following:

  - When to move files in the file system from primary storage to IA storage.
  - When to move files in the file system from primary storage or IA storage to Archive storage.
  - When to move files that are in IA or Archive storage to primary storage.

  > Amazon EFS requires that each `LifecyclePolicy` object have only a single transition. This means that in a request body, `LifecyclePolicies` needs to be structured as an array of `LifecyclePolicy` objects, one object for each transition, `TransitionToIA` , `TransitionToArchive` `TransitionToPrimaryStorageClass` . See the example requests in the following section for more information.

- `performanceMode`: string — The performance mode of the file system.

  We recommend `generalPurpose` performance mode for all file systems. File systems using the `maxIO` performance mode can scale to higher levels of aggregate throughput and operations per second with a tradeoff of slightly higher latencies for most file operations. The performance mode can't be changed after the file system has been created. The `maxIO` mode is not supported on One Zone file systems.

  > Due to the higher per-operation latencies with Max I/O, we recommend using General Purpose performance mode for all file systems.

  Default is `generalPurpose` .

- `provisionedThroughputInMibps`: number — The throughput, measured in mebibytes per second (MiBps), that you want to provision for a file system that you're creating.

  Required if `ThroughputMode` is set to `provisioned` . Valid values are 1-3414 MiBps, with the upper limit depending on Region. To increase this limit, contact Support . For more information, see [Amazon EFS quotas that you can increase](https://docs.aws.amazon.com/efs/latest/ug/limits.html#soft-limits) in the *Amazon EFS User Guide* .

- `replicationConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.ReplicationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.ReplicationConfigurationProperty.html) — Describes the replication configuration for a specific file system.

- `throughputMode`: string — Specifies the throughput mode for the file system.

  The mode can be `bursting` , `provisioned` , or `elastic` . If you set `ThroughputMode` to `provisioned` , you must also set a value for `ProvisionedThroughputInMibps` . After you create the file system, you can decrease your file system's Provisioned throughput or change between the throughput modes, with certain time restrictions. For more information, see [Specifying throughput with provisioned mode](https://docs.aws.amazon.com/efs/latest/ug/performance.html#provisioned-throughput) in the *Amazon EFS User Guide* .

  Default is `bursting` .

## Properties

- `attrArn`: string — The Amazon Resource Name (ARN) of the EFS file system.

  Example: `arn:aws:elasticfilesystem:us-west-2:1111333322228888:file-system/fs-0123456789abcdef8`

- `attrFileSystemId`: string — The ID of the EFS file system.

  For example: `fs-abcdef0123456789a`

- `availabilityZoneName`: string — For One Zone file systems, specify the AWS Availability Zone in which to create the file system.

- `backupPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.BackupPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.BackupPolicyProperty.html) — Use the `BackupPolicy` to turn automatic backups on or off for the file system.

- `bypassPolicyLockoutSafetyCheck`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — (Optional) A boolean that specifies whether or not to bypass the `FileSystemPolicy` lockout safety check.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `encrypted`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — A Boolean value that, if true, creates an encrypted file system.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `fileSystemPolicy`: any — The `FileSystemPolicy` for the EFS file system.

- `fileSystemProtection`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.FileSystemProtectionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.FileSystemProtectionProperty.html) — Describes the protection on the file system.

- `fileSystemRef`: [FileSystemReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_efs.FileSystemReference.html) — A reference to a FileSystem resource.

- `fileSystemTagsRaw`: [CfnFileSystem.ElasticFileSystemTagProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.ElasticFileSystemTagProperty.html)[] — Use to create one or more tags associated with the file system.

- `kmsKeyId`: string — The ID of the AWS KMS key to be used to protect the encrypted file system.

- `lifecyclePolicies`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.LifecyclePolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.LifecyclePolicyProperty.html)[] — An array of `LifecyclePolicy` objects that define the file system's `LifecycleConfiguration` object.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `performanceMode`: string — The performance mode of the file system.

- `provisionedThroughputInMibps`: number — The throughput, measured in mebibytes per second (MiBps), that you want to provision for a file system that you're creating.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `replicationConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.ReplicationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_efs.CfnFileSystem.ReplicationConfigurationProperty.html) — Describes the replication configuration for a specific file system.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `throughputMode`: string — Specifies the throughput mode for the file system.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForFileSystem(resource: IFileSystemRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromFileSystemArn(scope: Construct, id: string, arn: string): IFileSystemRef` (static) — Creates a new IFileSystemRef from an ARN.

- `fromFileSystemId(scope: Construct, id: string, fileSystemId: string): IFileSystemRef` (static) — Creates a new IFileSystemRef from a fileSystemId.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnFileSystem(x: any): boolean` (static) — Checks whether the given object is a CfnFileSystem.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
